<?php
/** 
 * 
 * @version 1.0.2
 * @author Piotr Kozdęba <piotr.ko@modulesgarden.com>
 */
class OPO_PageBuilder_PageBuilder
{
    private $smarty = null;
    private $template;
    private $variables = array();
    
    public function __construct($template)
    {
        $this->template = $template;
    }

    public function __set($name, $value)
    {
        $this->enableSmarty();
        $this->smarty->assign($name, $value);
    }
    
    public function setTemplate($template)
    {
        $this->template = $template;
    }
    
    private function enableSmarty()
    {
        if($this->smarty)
        {
            return true;
        }
        
        if(!class_exists('Smarty'))
        {
            if(file_exists(MAIN_WHMCS_DIR_.'includes'.DS.'smarty'.DS.'Smarty.class.php'))
            {
                require_once(MAIN_WHMCS_DIR_.'includes'.DS.'smarty'.DS.'Smarty.class.php');
            } else
            {
                die('Smarty does not exists.');
            }
        }
        
        $this->smarty = new Smarty();
    }
    
    public function build()
    {
        if(!file_exists($this->template))
        {
            die('File '.$this->template.' does not exists');
        }
        
        global $templates_compiledir;
        $this->enableSmarty();
        if (method_exists($this->smarty, 'muteExpectedErrors'))
        {
            $this->smarty->muteExpectedErrors();//whmcs 6 - since we have own error handler
        }
        
        $this->smarty->template_dir = dirname($this->template);
        $this->smarty->compile_dir = $templates_compiledir;
        $this->smarty->force_compile = 1;       
        
        
        foreach($this->variables as $key => $val)
        {
            $this->smarty->assign($key, $val);
        }
        
        $output = $this->smarty->fetch(substr($this->template,strlen(dirname($this->template).DS)), time());         
        
        return $output;
    }
    
    public function getVars() {
        return $this->variables;
    }
    
    public function setVar($name, $value)
    {
        $this->variables[$name] = $value;
    }
    
}


