<?php
/**
 * 
 * @version 1.0.1
 * @author Piotr Kozdęba <piotr.ko@modulesgarden.com>
 */
class OPO_WHMCS_Configuration 
{
    /**
     * 
     * @param string    $fieldname - null (default) to get full configuration info despite of only $fieldname value. Could also be an array of fieldnames to return
     * @return mixed FALSE if there is no such row
     */
    public static function get($fieldname= null)
    {
        $db = new OPO_Database_Database();
        $fieldname_query = array();
        if (null!==$fieldname && is_array($fieldname))
        {
            foreach($fieldname as $name)
            {
                $fieldname_query []= $db->escape($name);
            }
        }
        
        $valdb = $db->query(
            "SELECT ".((null===$fieldname || is_array($fieldname))?"`setting`,":"")."`value` FROM `tblconfiguration`".
            ($fieldname?" WHERE ".(is_array($fieldname)?"`setting` IN (".implode(',',$fieldname_query).")":"`setting`=".$db->escape($fieldname)):"")
        );
        
        if ($fieldname!==null && !is_array($fieldname))
        {
            $val = $valdb->get('value');
        }
        
        if ($fieldname===null || is_array($fieldname))
        {
            $val = $valdb->asArray('setting','value');
        }
        
        return $val;//($val!==FALSE?$val:FALSE); 
    }
    
    /**
     * 
     * @param string    $fieldname - name of the setting (could be an array with names). WARNING! If null it will update NOTHING
     * @param string    $value     - new setting value.
     * @return mixed FALSE if there is no such row
     */
    public static function set($fieldname,$value)
    {
        if (null===$fieldname) return FALSE;
            
        $db = new OPO_Database_Database();
        
        $fieldname_query = array();
        if (null!==$fieldname && is_array($fieldname))
        {
            foreach($fieldname as $name)
            {
                $fieldname_query []= $db->escape($name);
            }
        }
        
        $val = $db->query(
            "UPDATE `tblconfiguration`".
            "SET `value`=".$db->escape($value).
            " WHERE ".(is_array($fieldname)?"`setting` IN (".implode(',',$fieldname_query).")":"`setting`=".$db->escape($fieldname))
        )->affectedRows();
        
        return ($val>0?TRUE:FALSE);
    }
}